<div class="card-header">
    Ubah Gambar Avatar
</div>
<div class="card-body">
    <form class="manage-profile-foto-avatar" id="manage-profile-foto-avatar" action="" method="post">
    #{authenticityToken /}
        <input type="hidden" name="model.action" value="${action}">
        <input type="hidden" name="model.id" id="userId" value="${model?.id}">
        <div class="form-group has-feedback">
            <div class="row uploadFileAvatar">
                <label for="uploadfile" class="col-4 control-label">Gambar Avatar</label>
                <input type="file" name="model.uploadfile" id="uploadfile" class="col-12 form-control uploadfile"
                       placeholder="Silahkan pilih file yang akan diupload" required>
                <span class="form-control-feedback col-12 ket">
                    *) Untuk hasil gambar avatar yang lebih baik, disarankan ukuran gambar  150 x 150<br/>
                    **) Ekstensi file yang diperbolehkan adalah *.png, *.jpg dan *.jpeg dan tidak boleh dari 1 MB
                </span>
                <span class="help-block">
                    <strong>#{error 'model.uploadfile' /}</strong>
                </span>
            </div>
            <br/>
            <div class="row">
                <label class="col-4 control-label">Gambar Avatar Saat Ini: </label><br/>
            </div>
            <div class="row centered-element">
                <div class="hasilUpload">
                #{if model?.getAvatarImage() != null && user?.avatarIsExist()}
                    <a class="col-12 control-label" href="${model?.getAvatarImage()}">
                        <img src="${model?.getAvatarImage()}" height="150" width="150"/></a>
                #{/if}
                #{else}
                    <a class="col-12 control-label" href="/public/assets/img/profiles/default-avatar.png">
                        <img src="/public/assets/img/profiles/default-avatar.png" height="150" width="150"/></a>
                #{/else}
                </div>
            </div>
            <div class="row centered-element">
                <div class="ketHasilUpload">
                </div>
            </div>
        </div>
        <br/>
    </form>
</div>
#{set 'tabFotoAvatar' }
<style type="text/css">
    .ket {
        font-size: 12px !important;
    }
</style>
<link rel="stylesheet" type="text/css" href="@{'public/stylesheets/progress-bar.css'}"/>
<script type="text/javascript" src="@{'public/javascripts/jquery.blockui.js'}"></script>
<script type="text/javascript">
    let imageExtensions = ["jpg", "jpeg", "png"]
    let acceptImages = generateAccept(imageExtensions)

    function generateAccept(arr) {
        var accept = ''
        var glue = ''
        for (let item of arr) {
            accept += glue + '.' + item
            glue = ', '
        }
        return accept
    }

    function validImage(extension) {
        return imageExtensions.includes(extension)
    }

    function blockInsertAvatar() {
        $('.uploadFileAvatar').block({
            message: 'Please Wait ....<br/><br/>Uploading Avatar Image <br/><progress></progress>',
            baseZ: 2000,
            css: {
                backgroundColor: '#00000000',
                color: '#fff',
                border: "0px",
                fontSize: '20px',
                width: '50%',
            },
            overlayCSS: {
                backgroundColor: '#000000', opacity: 0.8
            }
        });
    }

    function unblockAvatar() {
        $('.uploadFileAvatar').unblock();
    }

    function uploadImageAvatar(image) {
        let id = $('#userId').val();
        var data = new FormData($('#manage-profile-foto-avatar')[0]);
        data.append("model.uploadfile", image);
        data.append("model.id", id);
        $.ajax({
            xhr: function () {
                var browser = navigator.appName;
                if (browser == "Microsoft Internet Explorer") {
                    var xhr = new window.ActiveXObject("Microsoft.XMLHTTP");
                } else {
                    var xhr = new window.XMLHttpRequest();
                }
                xhr.upload.addEventListener("progress", function (evt) {
                    if (evt.lengthComputable) {
                        var percentComplete = (evt.loaded / evt.total) * 100 + " %";
                        $('progress').attr({value: evt.loaded, max: evt.total});
                        $('.progress-value').html(percentComplete + '%');
                    }
                }, false);
                return xhr;
            },
            data: data,
            cache: false,
            contentType: false,
            processData: false,
            type: "post",
            url: "#{url route.user_management_userapicontroller_storeavatar /}",
            beforeSend: function () {
                blockInsertAvatar();
                $(window).bind("beforeunload", function (e) {
                    return e.originalEvent.returnValue;
                });
            },
            success: function (result) {
                var img = document.createElement("IMG");
                img.src = result.payload;
                img.width = 150;
                img.height = 150;
                $('.hasilUpload').empty()
                        .prepend('<a class="col-12 control-label" href="' + result.payload + '">')
                        .html(img).prepend('</a>').fadeIn("slow");

                $('.ketHasilUpload').empty()
                        .prepend('<br/><br/><span class="form-control-feedback col-12 ket">' +
                                '*) Silahkan logout dan login kembali untuk melihat perubahan ' +
                                'avatar pada pojok kiri atas</span>');
                document.getElementById('uploadfile').value = '';
            }

            ,
            complete: function () {
                unblockAvatar();
                $('progress').attr('value', '0.0');
                $(window).unbind("beforeunload");
            }
            ,
            error: function (result) {
                unblockAvatar();
                $('.alert-modal')
                        .addClass('alert-danger')
                        .removeClass('alert-success')
                        .removeClass('hidden').html('&{translation.general_error}');
            }
        })
        ;
    }

    $(document).ready(function () {
        $("#uploadfile").prop('accept', acceptImages);
        $("#uploadfile").change(function () {
            var image = $('#uploadfile')[0].files[0];
            let ext = image.name.split('.').pop();
            if (validImage(ext)) {
                if (image.size < 1048576) {
                    uploadImageAvatar(image);
                } else {
                    alert("Ukuran file gambar avatar yang dapat diunggah adalah " +
                            "tidak lebih dari 1 MB ");
                    document.getElementById('uploadfile').value = '';
                }
            } else {
                alert("Ekstensi file untuk gambar avatar tidak didukung. " +
                        "Hanya diperbolehkan ekstensi JPG, JPEG dan PNG");
                document.getElementById('uploadfile').value = '';
            }
        });
    });
</script>
#{/set}